//      Unpublished Confidential Information of Hewlett-Packard
//      Company. Do not disclose.  Copyright (c) Hewlett-Packard
//      Company 1995. All rights reserved
// 
// The contents of this software are proprietary and confidential to
// the Hewlett- Packard Company, and are limited in distribution to
// those with a direct need to know.  Individuals having access to
// this software are responsible for maintaining the confidentiality
// of the content and for keeping the software secure when not in use.
// Transfer to any party is strictly forbidden other than as expressly
// permitted in writing by Hewlett-Packard Company.  Unauthorized
// transfer to or possession by any unauthorized party may be a
// criminal offense.
//
//                  RESTRICTED RIGHTS LEGEND
//
//      Use,  duplication,  or disclosure by the U. S. Government is
//      subject to restrictions as set forth in subparagraph (c) (1)
//      (ii) in the Rights in Technical Data and Computer Software
//      clause in DFARS 252.227-7013 or any other successor clause.
//
//                      HEWLETT-PACKARD COMPANY
//                      3000 Hanover St.
//                      Palo Alto, CA  94304 U.S.A.
//
//      Rights for non-DOD U.S. Government Departments and Agencies
//      are as set forth in FAR 52.227-19 (c) (1,2) or any other
//      successor clause.

#ifndef _ARCIMEX_H_
#define _ARCIMEX_H_

#include "nsrLib.h"
#include "hash.h"
#include "arcTree.h"
#include "nsrJB.h"

// Some macros

#define HTABLE_SIZE     257             // A prime number near 256
#define MAX_NAMELENGTH  256

#define NULL_NSRTREENODE  0

#define MAX_IOSIZE        262144                // 256K chunks

// Return values for applications

#define TERM_NOERROR_NOSTATUS           0
#define TERM_ERROR                      1
#define TERM_NOERROR_TEST_FAILED        2
#define TERM_NOERROR_TEST_PASSED        3

// The root ICB address is not available to us from the Archive object, so
// for purposes of putting it in our hash table, we assign it a magic number.
// The sector address 0 is reserved by the format, so we won't have any
// conflicts.

#define ROOT_ICB_ADDRESS  0

#define DEFAULT_CMRFILE         "export.cmr"

#endif  // _ARCIMEX_H_
