//      Unpublished Confidential Information of Hewlett-Packard
//      Company. Do not disclose.  Copyright (c) Hewlett-Packard
//      Company 1995. All rights reserved
// 
// The contents of this software are proprietary and confidential to
// the Hewlett- Packard Company, and are limited in distribution to
// those with a direct need to know.  Individuals having access to
// this software are responsible for maintaining the confidentiality
// of the content and for keeping the software secure when not in use.
// Transfer to any party is strictly forbidden other than as expressly
// permitted in writing by Hewlett-Packard Company.  Unauthorized
// transfer to or possession by any unauthorized party may be a
// criminal offense.
//
//                  RESTRICTED RIGHTS LEGEND
//
//      Use,  duplication,  or disclosure by the U. S. Government is
//      subject to restrictions as set forth in subparagraph (c) (1)
//      (ii) in the Rights in Technical Data and Computer Software
//      clause in DFARS 252.227-7013 or any other successor clause.
//
//                      HEWLETT-PACKARD COMPANY
//                      3000 Hanover St.
//                      Palo Alto, CA  94304 U.S.A.
//
//      Rights for non-DOD U.S. Government Departments and Agencies
//      are as set forth in FAR 52.227-19 (c) (1,2) or any other
//      successor clause.

#ifndef _BSH_H_
#define _BSH_H_

#define MAX_CMDLINE     5120
#define MAX_LINE        2560
#define MAX_NODES       64

class browseShell
{
private:

    hpACDev     *acdev_;                // Autochanger device object
    TreeNode    root_;                  // Root node of file system
    TreeNode    cwd_;                   // Current working directory
    NSRJukeBox  *jbp_;

    // Private methods

    INT32       do_dirlist(int argc,char **argv);
    INT32       do_cd(int argc,char **argv);
    INT32       do_pwd(void);
    void        do_help(int argc,char **argv);
    INT32       do_restore(int argc,char **argv);
    INT32       do_vi(int argc,char **argv);
    INT32       do_fileInfo(int argc,char **argv);
    INT32       pathToNode(CHAR_PTR path,TreeNode& node);
    INT32       equalNodes(TreeNode& n1,TreeNode& n2);
    INT32       expandRegExps(CHAR_PTR buffer,INT32 size);
    void        convertRegExp(char *src,char *regexp);
    INT32       getArgs(char *buffer,INT32 *argc,char ***argv);
    void        freeArgs(INT32 argc,char **argv);
    char *      myfgets(char *buffer,int len,FILE *stream);

public:

                browseShell(hpACDev *acdev,NSRJukeBox *jb,TreeNode& root); 
                ~browseShell(void) {}           // Destructor
    INT32       start(void);                    // Start the shell
};

#endif  // _BSH_H_
