/*****************************************************************************
** dqueue.h:  Contains macros to implement a queue structure based on the
**            dlist doubly-linked list toolkit.
**
**      Unpublished Confidential Information of Hewlett-Packard
**      Company. Do not disclose.  Copyright (c) Hewlett-Packard
**      Company 1995. All rights reserved
** 
** The contents of this software are proprietary and confidential to
** the Hewlett- Packard Company, and are limited in distribution to
** those with a direct need to know.  Individuals having access to
** this software are responsible for maintaining the confidentiality
** of the content and for keeping the software secure when not in use.
** Transfer to any party is strictly forbidden other than as expressly
** permitted in writing by Hewlett-Packard Company.  Unauthorized
** transfer to or possession by any unauthorized party may be a
** criminal offense.
**
**                  RESTRICTED RIGHTS LEGEND
**
**      Use,  duplication,  or disclosure by the U. S. Government is
**      subject to restrictions as set forth in subparagraph (c) (1)
**      (ii) in the Rights in Technical Data and Computer Software
**      clause in DFARS 252.227-7013 or any other successor clause.
**
**                      HEWLETT-PACKARD COMPANY
**                      3000 Hanover St.
**                      Palo Alto, CA  94304 U.S.A.
**
**      Rights for non-DOD U.S. Government Departments and Agencies
**      are as set forth in FAR 52.227-19 (c) (1,2) or any other
**      successor clause.
**
** Programmer:  Jon Hirota
*****************************************************************************/

#ifndef _DQUEUE_H_
#define _DQUEUE_H_

#include <string.h>
#include "dlist.h"

#ifdef __cplusplus 
extern "C" {
#endif

/*
** The dqueue data types
*/

typedef dlist_node dqueue_node;
typedef dlist dqueue;

/*
** The dqueue macros
*/

#define dqueueCreate()                  dlistCreate((int (*)(void *,void *)) strcmp)
#define dqueueDestroy(queue)            dlistDestroy(queue)
#define dqueueEnqueue(queue,datap)      dlistAppend(queue,datap)
#define dqueueDequeue(queue)            dlistDelete(queue,dlistHead(queue))
#define dqueueApply(queue,applf,fs)     dlistApply(queue,applf,fs)
#define dqueueError(queue)              dlistError(queue)

#ifdef __cplusplus 
}
#endif

#endif          /* _DQUEUE_H_ */
