//-*-c++-*-
//-----------------------------------------------------------------------------
// syndata.h:  
// 
// This header file provides definitions and declarations for the 
// SynthData class.
//
//      Unpublished Confidential Information of Hewlett-Packard
//      Company. Do not disclose.  Copyright (c) Hewlett-Packard
//      Company 1995. All rights reserved
// 
// The contents of this software are proprietary and confidential to
// the Hewlett- Packard Company, and are limited in distribution to
// those with a direct need to know.  Individuals having access to
// this software are responsible for maintaining the confidentiality
// of the content and for keeping the software secure when not in use.
// Transfer to any party is strictly forbidden other than as expressly
// permitted in writing by Hewlett-Packard Company.  Unauthorized
// transfer to or possession by any unauthorized party may be a
// criminal offense.
//
//                  RESTRICTED RIGHTS LEGEND
//
//      Use,  duplication,  or disclosure by the U. S. Government is
//      subject to restrictions as set forth in subparagraph (c) (1)
//      (ii) in the Rights in Technical Data and Computer Software
//      clause in DFARS 252.227-7013 or any other successor clause.
//
//                      HEWLETT-PACKARD COMPANY
//                      3000 Hanover St.
//                      Palo Alto, CA  94304 U.S.A.
//
//      Rights for non-DOD U.S. Government Departments and Agencies
//      are as set forth in FAR 52.227-19 (c) (1,2) or any other
//      successor clause.
//
// CLASSES:
//
// SynthData
//
//-----------------------------------------------------------------------------
// $Source: /projects/HMS/nsr/udfAncil/msTest/syndata.h,v $
// $Revision: 1.2 $     $Author: hmgr $
// $State: Exp $        $Locker:  $
// $Date: 95/12/01 10:07:53 $
//-----------------------------------------------------------------------------
#ifndef _SYNDATA_H_                             // Allow multiple inclusion
#define _SYNDATA_H_

#include <stdio.h>
#include <stdlib.h>
#include <rw/cstring.h>

//-----------------------------------------------------------------------------
// CLASS:  SynthData                                    --TRP
//
// Synthetic data creation class.
// 
// PUBLIC DATA MEMBERS:
//
// RWCString    data_
//
// PUBLIC METHODS:
//
// SynthData()
//      Constructor.  Creates data.
// ~SynthData()
//      Destructor
// data()
//      Return pointer to data as unsigned char *.
//
// USAGE NOTES:
//      This class is in its own file to minimize linkage for arcRead.  arcRead
//      does not use any arcSynth members.
//-----------------------------------------------------------------------------
// COLLABORATORS:
//
// PRIVATE DATA MEMBERS:        None.
//
// PRIVATE METHODS:             None.
//
// IMPLEMENTATION NOTES:        None.
//-----------------------------------------------------------------------------

#ifndef MAX_IOSIZE
#define MAX_IOSIZE 262144
#endif
#define OFFSET_STRLEN 14

#include <string.h>

class SynthData
{
public:
    SynthData(const char* seed, const long offset, const long len);
    SynthData(){ needToMake = TRUE;}
    
    ~SynthData();
    const unsigned char* data();
    void  makeData(const char* seed, const long offset, const long len);
private:
    char* data_;
    char* sOffset;
    RWBoolean needToMake;
};

#endif //_SYNDATA_H_
