%{
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "cmrYacc.h"

int nLine = 1;

%}

ws                      [ \t]+
comment                 #.*
qstring                 \"[^\"\n]*[\"\n]
id                      [a-zA-Z][a-zA-Z0-9]*
nl                      \n

zero                    0
dec_integer             [1-9]+[0-9]*
octal_integer           0[0-7]+
hex_integer             0[xX][0-9a-fA-F]+

%s DEFINE_DIR

%%

\n                      { nLine++; }
                        ;

{ws}      ;
{comment} ;

{zero} |
{dec_integer} |
{octal_integer} |
{hex_integer}           {cmrlval.string = strdup(cmrtext);
                         return INTEGER;}


{qstring} { cmrlval.string = strdup(cmrtext+1); /* skip open quote */
            if(cmrlval.string[cmrleng-2] != '"')
                fprintf(stderr, "Unterminated character string",(char *)0);
            else
                cmrlval.string[cmrleng-2] = '\0'; /* remove close quote */
            return QSTRING;
          }

    /* fileset */

begin_fileset |
bs                      { return BEGIN_FILESET; }

end_fileset |
es                      { return END_FILESET; }

    /* directory */

begin_dir |
bd                      { BEGIN DEFINE_DIR;
                        return BEGIN_DIR; }
 
end_dir |
ed                      { return END_DIR; } 

begin_entries |
be                      { return BEGIN_ENTRIES; }

end_entries |
ee                      { return END_ENTRIES; }

    /* file */

begin_file |
bf                      { return BEGIN_FILE; }

end_file |
ef                      { return END_FILE; }

    /* symbolic link */

begin_symlink |
by                      { return BEGIN_SYMLINK; }

end_symlink |
ey                      { return END_SYMLINK; }

begin_path |
bp                      { return BEGIN_PATH; }

end_path |
ep                      { return END_PATH; }

PATH_STANDARD_ROOT |
PATH_PARENT |
PATH_UKNOWN |
PATH_SAME |
PATH_CUSTOM_ROOT        { cmrlval.string = strdup(cmrtext);
                                return QSTRING;
                        }

    /* common info */

begin_common |
bc                      { return BEGIN_COMMON; }

end_common |
ec                      { return END_COMMON; }

    /* allocation */

begin_allocation |
bl                      { return BEGIN_ALLOCATION; }

end_allocation |
el                      { return END_ALLOCATION; }

extent |
ex                      { return EXTENT; }

%%

void 
cmrerror (char *s) 
{
        printf ("%s on line %d, at %s\n", s, nLine, cmrtext);
}

int cmrwrap()
{
    return 1; // tell parser to stop at eof
}




















